#include "sys.h"
#include "delay.h"  
#include "usart.h"   
#include "led.h"
#include "key.h"  
#include "LT738_Lib.h"
#include "LT738_Demo.h"
#include "touch.h" 



#if TFT480272
extern  unsigned char  gImage_home480272[];
#endif
#if TFT800480
extern  unsigned char  gImage_smarthome800480[];//piczhuomian
#endif
#if TFT1024600
extern  unsigned char  gImage_smarthome800480[];//piczhuomian
#endif
#if TFT1024768
extern  unsigned char  gImage_smarthome800480[];//piczhuomian
#endif

const u16 POINT_COLOR_TBL[5]={Red,Green,Blue,Cyan,Magenta}; 

//void Display_picture(unsigned short x,unsigned short y,unsigned short w,unsigned short h, const unsigned char *bmp);


#if 1

//ĻϽʾ"RST"
void Load_Drow_Dialog(void)
{
	LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,color16M_white);//  
	LT738_Select_Internal_Font_Init(24,1,1,0,1);
	LT738_Print_Internal_Font_String(LCD_XSIZE_TFT-40,0,Red,White,"RST");	
	//LCD_ShowString(lcddev.width-24,0,200,16,16,"RST");//ʾ 
}
  
 
//һ
//(x1,y1),(x2,y2):ʼ
//sizeĴϸ̶
//colorɫ
void lcd_draw_bline(u16 x1, u16 y1, u16 x2, u16 y2,u8 size,u16 color)
{
	u16 t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 
	if(x1<size|| x2<size||y1<size|| y2<size)return; 
	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		//gui_fill_circle(uRow,uCol,size,color);// 
		LT738_DrawCircle_Fill(uRow,uCol,size,color);
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}   

#endif

#if 0
void rtp_test(void)
{
	u8 key;
	u8 i=0;	  
	while(1)
	{
	  key=KEY_Scan(0);
	  tp_dev.scan(0);  		 
		if(tp_dev.sta&TP_PRES_DOWN)			//
		{	
		 	if(tp_dev.x[0]<320&&tp_dev.y[0]<240)
			{	
				if(tp_dev.x[0]>(320-24)&&tp_dev.y[0]<16)Load_Drow_Dialog();//
				
				else LT738_DrawCircle_Fill(tp_dev.x[0],tp_dev.y[0],1,Red);//TP_Draw_Big_Point(tp_dev.x[0],tp_dev.y[0],Red);//ͼ	  			   
			}
		}else delay_ms(10);	//ûаµʱ 	    
		if(key==KEY2_PRES)	//KEY2,ִУ׼
		{
			LT738_DrawSquare_Fill(0,0,320,240,color16M_white);//LCD_Clear(WHITE);	//
			TP_Adjust();  	//ĻУ׼ 
			TP_Save_Adjdata();	 
			Load_Drow_Dialog();
		}
		i++;
		if(i%20==0)LED0=!LED0;
	}
}

#endif

#if 1


void ctp_test(void)
{
	u8 t=0;
	u8 i=0;	  	    
 	u16 lastpos[5][2];		//һε 
	Load_Drow_Dialog();
	while(1)
	{
		  tp_dev.scan(0);	

		for(t=0;t<5;t++)  //ֵ֧ĵ,̶Ϊ5
		{
			if((tp_dev.sta)&(1<<t))
			{
				if(tp_dev.x[t]<LCD_XSIZE_TFT&&tp_dev.x[t]>0&&tp_dev.y[t]<LCD_YSIZE_TFT&&tp_dev.y[t]>0)
				{
					if(lastpos[t][0]==0XFFFF)
					{
						lastpos[t][0] = tp_dev.x[t];
						lastpos[t][1] = tp_dev.y[t];
					}
					lcd_draw_bline(lastpos[t][0],lastpos[t][1],tp_dev.x[t],tp_dev.y[t],1,POINT_COLOR_TBL[t]);//
					lastpos[t][0]=tp_dev.x[t];
					lastpos[t][1]=tp_dev.y[t];
					if(tp_dev.x[t]>(LCD_XSIZE_TFT-40)&&tp_dev.y[t]<24)
					{
						Load_Drow_Dialog();//
					}
				}
			}else lastpos[t][0]=0XFFFF;
		}
		
		delay_ms(5);i++;
		if(i%20==0)LED0=!LED0;
	}	
}
#endif


int main(void)
{ 
  u8 i=0;
//	u8 tempCMD=0;
//	u8 key;
	u8 m=1;
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);         //ʼʱ
	uart_init(115200);		 //ʼڲΪ115200	
	LED_Init();				 //ʼLED 
	KEY_Init(); 			 //ʼ 
	Parallel_Init();         // STM32LT738Ľӿڳʼ
	printf("Parallel_Init ok:\r\n"); //ӡ
	LT738_Init();            // LT738ʼ
	printf("LT738_Init ok:\r\n"); //ӡ
	tp_dev.init();

	//LT738_PWM1_Init(1,0,1,20,100);
	Display_ON();

	
	test_FSMCIO();
	
	//LCD_CmdWrite(0x19);
  //tempCMD =LCD_DataRead();
	//printf("LCD ID:%x\r\n",LCD_RegisterRead(0x19)); //ӡȡֵ
	
	Delay_ms(50);	
	//#if 1
	//Select_Main_Window_24bpp();						//ѡʾɫ
	Select_Main_Window_16bpp();						//ѡʾɫ
	Main_Image_Start_Address(layer1_start_addr);	//趨ʼַSDRAMʾĻݵʼַ
	Main_Image_Width(LCD_XSIZE_TFT);				//趨ڵĿ
	Main_Window_Start_XY(0,0);						//趨ʾʼ
	Canvas_Image_Start_address(layer1_start_addr);	//趨д뵽SDRAMʼַ
	Canvas_image_width(LCD_XSIZE_TFT);				//趨дSDRAMĿȣΪ4ı
  Active_Window_XY(0,0);							//趨ڵ
	Active_Window_WH(LCD_XSIZE_TFT,LCD_YSIZE_TFT);	//趨ڵĿȣΪ4ı͸߶
			Main_Window_Start_XY(0,0);	
    LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
		LT738_Select_Internal_Font_Init(24,2,2,1,1);
		LT738_Print_Internal_Font_String(64,40,Red,White ,"PWM TEST");
		//LT738_Print_Internal_Font_String(222,240,Red,White ,"Waiken Smart");
		for(i = 0 ; i < 85 ; i++)
	{
    
		  LT738_PWM1_Init(1,0,1,50,10+i);
		  delay_ms(60);

	}
	
	#if 0
	
	  while(1)
		{
			
		//	key=KEY_Scan(0); 	//õֵ
		//	if(key==2)  m++;    //KEY1·
		//	else if(key==3) m--;//KEY2Ϸ			
			switch(m)			
			{			
				case 1:	
				LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Red);
				break;					
				case 2:	
				LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Green);
				break;								
				case 3:	
				LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Blue );
				break;			
				case 4:	
				LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Black );
				break;		
				case 5:
				LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
				break;
				case 6:
				LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Grey);
				break;
				case 7:
				GRAY_32();//ʾ32ҽ
				break;
				case 8:
				WB_block();//ʾ̸
				break;
				case 9:
				LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
		    LT738_DrawCircle(30,30,30-1,Red);
		    LT738_DrawCircle(30,LCD_YSIZE_TFT-30,30-1,Blue);
		    LT738_DrawCircle(LCD_XSIZE_TFT-30,LCD_YSIZE_TFT-30,30-1,Green);
		    LT738_DrawCircle(LCD_XSIZE_TFT-30,30,30-1,Yellow);
		    LT738_DrawSquare(0,0,LCD_XSIZE_TFT-1,LCD_YSIZE_TFT-1,Red);
				break;
				case 10:
				LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Black );
				#if TFT480272
				Display_picture(0,0,480,272,gImage_home480272);
				#endif
				
				#if TFT800480
				Display_picture(0,0,800,480,gImage_smarthome800480);
				#endif
				
				#if TFT1024600
				Display_picture((LCD_XSIZE_TFT-800)/2,(LCD_YSIZE_TFT-480)/2,800,480,gImage_smarthome800480);
				#endif
				
				#if TFT1024768
				Display_picture((LCD_XSIZE_TFT-800)/2,(LCD_YSIZE_TFT-480)/2,800,480,gImage_smarthome800480);
				#endif
				//Display_picture((1024-800)/2,(600-480)/2,800,480,gImage_smarthome800480);
				break;
				
				case 11:
				{
					Load_Drow_Dialog();
		     //rtp_test();
		     ctp_test();
				 }
				break;
							
			}
			if(KEY2==0)	Waiting_Key();
			if(KEY2==0&KEY1==0)
			{
				Load_Drow_Dialog();
		     //rtp_test();
		     ctp_test();
			}
			else 
			m++;
			delay_ms(2000);
			
			if(m==11) m=1;
			if(m==0)  m=11;
			
		}
		
#endif
	
	
	
	#if 1
	
	while(1)
	{ 
    
	//	LT738_PWM1_Init(1,0,1,200,50);
		//þκȫ졢̡ɫ
		LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Red);
	 // delay_ms(2000);
		WaitKey();
		LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Green);
    //delay_ms(2000);
		WaitKey();
		LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Blue );
		//delay_ms(2000);
		WaitKey();
		LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Black );
	  //delay_ms(2000);
		WaitKey();
		LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
		//delay_ms(2000);
		WaitKey();
		LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Grey);
	  //delay_ms(2000);
		WaitKey();
		LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
		LT738_DrawCircle(30,30,30-1,Red);
		LT738_DrawCircle(30,LCD_YSIZE_TFT-30,30-1,Blue);
		LT738_DrawCircle(LCD_XSIZE_TFT-30,LCD_YSIZE_TFT-30,30-1,Green);
		LT738_DrawCircle(LCD_XSIZE_TFT-30,30,30-1,Yellow);
		LT738_DrawSquare(0,0,LCD_XSIZE_TFT-1,LCD_YSIZE_TFT-1,Red);
		//delay_ms(2000);
		WaitKey();	
		
		GRAY_32();//ʾ32ҽ
		//delay_ms(2000);
		WaitKey();
    WB_block();//ʾ̸
		//delay_ms(2000);
		WaitKey();

			LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,Black );
				#if TFT480272
				Display_picture(0,0,480,272,gImage_home480272);
				#endif
				
				#if TFT800480
				Display_picture(0,0,800,480,gImage_smarthome800480);
				#endif
				
				#if TFT1024600
				Display_picture((LCD_XSIZE_TFT-800)/2,(LCD_YSIZE_TFT-480)/2,800,480,gImage_smarthome800480);				
				#endif
				
				#if TFT1024768
        Display_picture((LCD_XSIZE_TFT-800)/2,(LCD_YSIZE_TFT-480)/2,800,480,gImage_smarthome800480);			
        #endif
				//Display_picture((1024-800)/2,(600-480)/2,800,480,gImage_smarthome800480);
	     WaitKey();


	//	Load_Drow_Dialog();
		//rtp_test();
		ctp_test();
	}
	
	#endif 

}
