/********************* COPYRIGHT  **********************
* File Name        : if_port.h
* Author           : Levetop Electronics
* Version          : V1.0
* Date             : 2017-9-11
* Description      : ѡͬӿ
********************************************************/

#ifndef _if_port_h
#define _if_port_h
#include "sys.h"      // STM32ͷļ

//ѡͨŷʽ

#define STM32_FSMC_8	0		// ʹSTM32FSMCLT768(STM32Ӳģ8080(8λ))
#define STM32_FSMC_16	1		// ʹSTM32FSMCLT738(STM32Ӳģ8080(16λ))
#define STM32_SPI		0		// ʹSTM32SPILT738



//ѡ8λ8080
#if STM32_FSMC_8
#define LCD_BASE0        ((u32)(0x6C000000 | 0x0000007E))
#define LCD_BASE1        ((u32)(0x6C000000 | 0x00000080))
#endif

//ѡ16λ8080
#if STM32_FSMC_16
#define LCD_BASE0        ((u32)(0x6C000000 | 0x0000007E))
#define LCD_BASE1        ((u32)(0x6C000000 | 0x00000080))
//#define LCD             ((LCD_TypeDef *) LCD_BASE)
#endif

//ѡSPI
#if STM32_SPI
//SPIģʽ
//4ߴģʽ
//IO
#define SPI_SDIN()  {GPIOE->MODER&=~(3<<(2*2);GPIOE->MODER|=0<<2*2;}///PF11ģʽ
#define SPI_SDOUT() {GPIOE->MODER&=~(3<<(2*3));GPIOE->MODER|=1<<2*3;} 	//PF11ģʽ

										
//-----------------˿ڶ----------------  					   
//#define SPI_CS 	PEout(7)
 
//ʹ4ߴнӿʱʹ 
//#define SPI_SCLK 	PEout(10)
//#define SPI_SDO 	PEout(8)
//#define SPI_SDI 	PEin(9)


#define SPI_CS 	PEout(0)
 
//ʹ4ߴнӿʱʹ 
#define SPI_SCLK 	PEout(1)
#define SPI_SDO 	PEout(2)
#define SPI_SDI 	PEin(3)
#endif




void Parallel_Init(void);
void FSMC_IO_Init(void);

void LCD_CmdWrite(u8 cmd);
void LCD_DataWrite(u8 data);
void LCD_DataWrite_Pixel(u16 data);
u8 LCD_StatusRead(void);
u16 LCD_DataRead(void);
	 
void Delay_us(u16 time); //ʱus
void Delay_ms(u16 time); //ʱms

void test_FSMCIO(void);

void FMSC_16_DataWrite_Pixel(u16 data);



#endif
