#include "gt9271.h"
#include "touch.h"
#include "LT738_Lib.h"
#include "ctiic.h"
#include "usart.h"
#include "delay.h" 
#include "string.h" 


//GT9271ò
//һֽΪ汾(0X41),뱣֤µİ汾ŴڵGT9271ڲ
//flashԭа汾,Ż.
//ֱ1280*800

//0x8047~0x8100  186Ĵ
//0x8047~0x0x80FE   184ĴΪ
//0x80FFΪУ
//0x8100 Flash±

const u8 GT9271_CFG_TBL[]=
{ 
	0x42,0x00,0x04,0x58,0x02,0x0A,0x3D,0x20,0x01,0x0A,
	0x28,0x0F,0x6E,0x5A,0x03,0x05,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x18,0x1A,0x1E,0x14,0x8F,0x2F,0xAA,
	0x26,0x24,0x0C,0x08,0x00,0x00,0x00,0x81,0x03,0x2D,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x1A,0x3C,0x94,0xC5,0x02,0x07,0x00,0x00,0x04,
	0x9E,0x1C,0x00,0x89,0x21,0x00,0x77,0x27,0x00,0x68,
	0x2E,0x00,0x5B,0x37,0x00,0x5B,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x19,0x18,0x17,0x16,0x15,0x14,0x11,0x10,
	0x0F,0x0E,0x0D,0x0C,0x09,0x08,0x07,0x06,0x05,0x04,
	0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x02,0x04,0x06,0x07,0x08,0x0A,0x0C,
	0x0D,0x0F,0x10,0x11,0x12,0x13,0x14,0x19,0x1B,0x1C,
	0x1E,0x1F,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x26,0x01
};  

/*

//GT9271ò
//mode:0,浽flash
//     1,浽flash
u8 GT9271_Send_Cfg(u8 mode)
{
	u8 buf[2];
	u8 i=0;
	buf[0]=0;
	buf[1]=mode;	//Ƿд뵽GT9271 FLASH?  Ƿ籣
	for(i=0;i<sizeof(GT9271_CFG_TBL);i++)buf[0]+=GT9271_CFG_TBL[i];//У
    buf[0]=(~buf[0])+1;
	GT9271_WR_Reg(GT9271_CFGS_REG,(u8*)GT9271_CFG_TBL,sizeof(GT9271_CFG_TBL));//ͼĴ
	GT9271_WR_Reg(GT9271_CHECK_REG,buf,2);//дУ,ø±
	return 0;
} 

*/


u8 GT9271_Send_Cfg(u8 mode)
{
	u8 buf[2];
	u8 i=0;
	buf[0]=0;
	buf[1]=mode;	//Ƿд뵽GT9271 FLASH?  Ƿ籣
	for(i=0;i<(sizeof(GT9271_CFG_TBL)-2);i++)buf[0]+=GT9271_CFG_TBL[i];//У
  buf[0]=(~buf[0])+1;
	//printf("Config_Chksum:0x%x\r\n",buf[0]);
	GT9271_WR_Reg(GT9271_CFGS_REG,(u8*)GT9271_CFG_TBL,sizeof(GT9271_CFG_TBL));//ͼĴ
	//GT9271_WR_Reg(GT9271_CHECK_REG,buf,2);//дУ,ø±
	return 0;
} 


//GT9271дһ
//reg:ʼĴַ
//buf:ݻ
//len:дݳ
//ֵ:0,ɹ;1,ʧ.
u8 GT9271_WR_Reg(u16 reg,u8 *buf,u8 len)
{
	u8 i;
	u8 ret=0;
	CT_IIC_Start();	
 	CT_IIC_Send_Byte(GT9271_CMD_WR);   	//д 	 
	CT_IIC_Wait_Ack();
	CT_IIC_Send_Byte(reg>>8);   	//͸8λַ
	CT_IIC_Wait_Ack(); 	 										  		   
	CT_IIC_Send_Byte(reg&0XFF);   	//͵8λַ
	CT_IIC_Wait_Ack();  
	for(i=0;i<len;i++)
	{	   
    	CT_IIC_Send_Byte(buf[i]);  	//
		ret=CT_IIC_Wait_Ack();
		if(ret)break;  
	}
    CT_IIC_Stop();					//һֹͣ	    
	return ret; 
}
//GT9271һ
//reg:ʼĴַ
//buf:ݻ
//len:ݳ			  
void GT9271_RD_Reg(u16 reg,u8 *buf,u8 len)
{
		u8 i; 
		CT_IIC_Start();	
		CT_IIC_Send_Byte(GT9271_CMD_WR);   //д 	 
		CT_IIC_Wait_Ack();
		CT_IIC_Send_Byte(reg>>8);   	//͸8λַ
		CT_IIC_Wait_Ack(); 	 										  		   
		CT_IIC_Send_Byte(reg&0XFF);   	//͵8λַ
		CT_IIC_Wait_Ack();  
		CT_IIC_Start();  	 	   
		CT_IIC_Send_Byte(GT9271_CMD_RD);   //Ͷ		   
		CT_IIC_Wait_Ack();	   
		for(i=0;i<len;i++)
		{	   
				buf[i]=CT_IIC_Read_Byte(i==(len-1)?0:1); //	  
		} 
			CT_IIC_Stop();//һֹͣ    
		} 
		//ʼGT9271
		//ֵ:0,ʼɹ;1,ʼʧ 
u8 GT9271_Init(void)
	{
			u8 temp[5]; 
	GPIO_InitTypeDef  GPIO_InitStructure;	
	
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB|RCC_AHB1Periph_GPIOC, ENABLE);//ʹGPIOB,Cʱ

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1 ;//PB1Ϊ(INT)
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;//ģʽ
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;//
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;//100MHz
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//
	GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ
		
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;//PC13Ϊ(RST)
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
	GPIO_Init(GPIOC, &GPIO_InitStructure);//ʼ	
	
	CT_IIC_Init();  //ʼI2C  
	GT9271_RST=0;	    //λ
	delay_ms(10);
 	GT9271_RST=1;	   //ͷŸλ		    
	delay_ms(10); 
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;//PB1Ϊ(INT)
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ	
			delay_ms(100);  
			GT9271_RD_Reg(GT9271_PID_REG,temp,4);//ȡƷID
			temp[4]=0;
			printf("CTP ID:GT%s\r\n",temp);	//ӡID
			GT9271_RD_Reg(0x8047,temp,1);
			printf("̼汾:0x%x\r\n",temp[0]);
			
		  if(temp[0]<0x43)//Ĭϰ汾Ƚϵ,Ҫflash
			{
				GT9271_Send_Cfg(1);//²
			}

			
			GT9271_RD_Reg(0x80FF,temp,1);
			printf("Config_Chksum:0x%x\r\n\r\n",temp[0]);
/*
			GT9271_RD_Reg(0x8048,temp,2);
			printf("Xֱ:%d\r\n\r\n",(temp[1]<<8|temp[0]));

			GT9271_RD_Reg(0x804A,temp,2);
			printf("Yֱ:%d\r\n\r\n",(temp[1]<<8|temp[0]));

			GT9271_RD_Reg(0x804D,temp,1);//
			printf("INT_trigger:0x%x\r\n\r\n",temp[0]);

			GT9271_RD_Reg(0x80FF,temp,1);//
			printf("Config_Chksum:0x%x\r\n\r\n",temp[0]);
			
		  //GT9271_RD_Reg(0x8100,temp,1);//
			//printf("Config_Flash:0x%x\r\n",temp[0]);
	*/
	

			
			return 0;

}

const u16 GT9271_TPX_TBL[5]={GT9271_TP1_REG,GT9271_TP2_REG,GT9271_TP3_REG,GT9271_TP4_REG,GT9271_TP5_REG};
//ɨ败(òѯʽ)
//mode:0,ɨ.
//ֵ:ǰ״̬.
//0,޴;1,д
u8 GT9271_Scan(u8 mode)
{
	u8 buf[4];
	u8 i=0;
	u8 res=0;
	u8 temp;
	u8 tempsta;
 	static u8 t=0;//Ʋѯ,ӶCPUռ   
	t++;
	if((t%10)==0||t<10)//ʱ,ÿ10CTP_Scanż1,ӶʡCPUʹ
	{
		GT9271_RD_Reg(GT9271_GSTID_REG,&mode,1);	//ȡ״̬  
 		if(mode&0X80&&((mode&0XF)<6))
		{
			temp=0;
			GT9271_WR_Reg(GT9271_GSTID_REG,&temp,1);//־ 		
		}		
		if((mode&0XF)&&((mode&0XF)<6))
		{
			temp=0XFF<<(mode&0XF);	//ĸתΪ1λ,ƥtp_dev.sta 
			tempsta=tp_dev.sta;			//浱ǰtp_dev.staֵ
			tp_dev.sta=(~temp)|TP_PRES_DOWN|TP_CATH_PRES; 
			tp_dev.x[4]=tp_dev.x[0];//津0
			tp_dev.y[4]=tp_dev.y[0];
			for(i=0;i<5;i++)
			{
				if(tp_dev.sta&(1<<i))	//Ч?
				{
					GT9271_RD_Reg(GT9271_TPX_TBL[i],buf,4);	//ȡXYֵ
					tp_dev.x[i]=(((u16)buf[1]<<8)+buf[0]);
					tp_dev.y[i]=(((u16)buf[3]<<8)+buf[2]);
					printf("x[%d]:%d,y[%d]:%d\r\n",i,tp_dev.x[i],i,tp_dev.y[i]);
				}			
			} 
			res=1;
			if(tp_dev.x[0]>LCD_XSIZE_TFT||tp_dev.y[0]>LCD_YSIZE_TFT)//Ƿ(곬)
			{ 
				if((mode&0XF)>1)		//,򸴵ڶݵһ.
				{
					tp_dev.x[0]=tp_dev.x[1];
					tp_dev.y[0]=tp_dev.y[1];
					t=0;				//һ,10,Ӷ
				}else					//Ƿ,Դ˴(ԭԭ)  
				{
					tp_dev.x[0]=tp_dev.x[4];
					tp_dev.y[0]=tp_dev.y[4];
					mode=0X80;		
					tp_dev.sta=tempsta;	//ָtp_dev.sta
				}
			}else t=0;					//һ,10,Ӷ
		}
	}
	if((mode&0X8F)==0X80)//޴㰴
	{ 
		if(tp_dev.sta&TP_PRES_DOWN)	//֮ǰǱµ
		{
			tp_dev.sta&=~(1<<7);	//ǰɿ
		}else						//֮ǰûб
		{ 
			tp_dev.x[0]=0xffff;
			tp_dev.y[0]=0xffff;
			tp_dev.sta&=0XE0;	//Ч	
		}	 
	} 	
	if(t>240)t=10;//´10ʼ
	return res;
}
 



























