#include "touch.h" 
#include "delay.h"
#include "stdlib.h"
#include "math.h"
#include "font.h" 
#include "24cxx.h" 
#include "LT738_Lib.h"

_m_tp_dev tp_dev=
{
	TP_Init,
	TP_Scan,
	TP_Adjust,
	0,
	0, 
	0,
	0,
	0,
	0,	  	 		
	0,
	0,	  	 		
};				


#if 1

//ĬΪtouchtype=0.
u8 CMD_RDX=0XD0;
u8 CMD_RDY=0X90;
 	 			    					   
//SPIд
//ICд1byte    
//num:Ҫд
void TP_Write_Byte(u8 num)    
{  
	u8 count=0;   
	for(count=0;count<8;count++)  
	{ 	  
		if(num&0x80)TDIN=1;  
		else TDIN=0;   
		num<<=1;    
		TCLK=0; 
		delay_us(1);
		TCLK=1;		//Ч	        
	}		 			    
} 		 
//SPI 
//ӴICȡadcֵ
//CMD:ָ
//ֵ:	   
u16 TP_Read_AD(u8 CMD)	  
{ 	 
	u8 count=0; 	  
	u16 Num=0; 
	TCLK=0;		//ʱ 	 
	TDIN=0; 	//
	TCS=0; 		//ѡдIC
	TP_Write_Byte(CMD);//
	delay_us(6);//ADS7846תʱΪ6us
	TCLK=0; 	     	    
	delay_us(1);    	   
	TCLK=1;		//1ʱӣBUSY
	delay_us(1);    
	TCLK=0; 	     	    
	for(count=0;count<16;count++)//16λ,ֻи12λЧ 
	{ 				  
		Num<<=1; 	 
		TCLK=0;	//½Ч  	    	   
		delay_us(1);    
 		TCLK=1;
 		if(DOUT)Num++; 		 
	}  	
	Num>>=4;   	//ֻи12λЧ.
	TCS=1;		//ͷƬѡ	 
	return(Num);   
}
//ȡһֵ(xy)
//ȡREAD_TIMES,Щ,
//ȻȥͺLOST_VAL,ȡƽֵ 
//xy:ָCMD_RDX/CMD_RDY
//ֵ:
#define READ_TIMES 5 	//ȡ
#define LOST_VAL 1	  	//ֵ
u16 TP_Read_XOY(u8 xy)
{
	u16 i, j;
	u16 buf[READ_TIMES];
	u16 sum=0;
	u16 temp;
	for(i=0;i<READ_TIMES;i++)buf[i]=TP_Read_AD(xy);		 		    
	for(i=0;i<READ_TIMES-1; i++)//
	{
		for(j=i+1;j<READ_TIMES;j++)
		{
			if(buf[i]>buf[j])//
			{
				temp=buf[i];
				buf[i]=buf[j];
				buf[j]=temp;
			}
		}
	}	  
	sum=0;
	for(i=LOST_VAL;i<READ_TIMES-LOST_VAL;i++)sum+=buf[i];
	temp=sum/(READ_TIMES-2*LOST_VAL);
	return temp;   
} 
//ȡx,y
//Сֵ100.
//x,y:ȡֵ
//ֵ:0,ʧ;1,ɹ
u8 TP_Read_XY(u16 *x,u16 *y)
{
	u16 xtemp,ytemp;			 	 		  
	xtemp=TP_Read_XOY(CMD_RDX);
	ytemp=TP_Read_XOY(CMD_RDY);	  												   
	//if(xtemp<100||ytemp<100)return 0;//ʧ
	*x=xtemp;
	*y=ytemp;
	return 1;//ɹ
}
//2ζȡIC,εƫܳ
//ERR_RANGE,,Ϊȷ,.	   
//úܴ׼ȷ
//x,y:ȡֵ
//ֵ:0,ʧ;1,ɹ
#define ERR_RANGE 50 //Χ 
u8 TP_Read_XY2(u16 *x,u16 *y) 
{
	u16 x1,y1;
 	u16 x2,y2;
 	u8 flag;    
    flag=TP_Read_XY(&x1,&y1);   
    if(flag==0)return(0);
    flag=TP_Read_XY(&x2,&y2);	   
    if(flag==0)return(0);   
    if(((x2<=x1&&x1<x2+ERR_RANGE)||(x1<=x2&&x2<x1+ERR_RANGE))//ǰβ+-50
    &&((y2<=y1&&y1<y2+ERR_RANGE)||(y1<=y2&&y2<y1+ERR_RANGE)))
    {
        *x=(x1+x2)/2;
        *y=(y1+y2)/2;
        return 1;
    }else return 0;	  
}  





void TP_Drow_Touch_Point(u16 x,u16 y,u16 color)
{

	LT738_DrawLine(x-12,y,x+13,y,Red);
	LT738_DrawLine(x,y-12,x,y+13,Red);
	LT738_DrawCircle(x,y,6,Red);
	//LCD_DrawPoint(x+1,y+1);
	//LCD_DrawPoint(x-1,y+1);
	//LCD_DrawPoint(x+1,y-1);
	//LCD_DrawPoint(x-1,y-1);
	//LCD_Draw_Circle(x,y,6);//Ȧ
}


void TP_Draw_Big_Point(u16 x,u16 y,u16 color)
{	    
	LT738_DrawCircle_Fill(x,y,1,color);
 
	
}


//ָλʾһַ
//x,y:ʼ
//num:Ҫʾַ:" "--->"~"
//size:С 12/16/24
//mode:ӷʽ(1)Ƿǵӷʽ(0)
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode)
{  							  
    u8 temp,t1,t;
	u16 y0=y;
	u8 csize=(size/8+((size%8)?1:0))*(size/2);		//õһַӦռֽ	
 	num=num-' ';//õƫƺֵASCIIֿǴӿոʼȡģ-' 'ǶӦַֿ⣩
	for(t=0;t<csize;t++)
	{   
		if(size==12)temp=asc2_1206[num][t]; 	 	//1206
		else if(size==16)temp=asc2_1608[num][t];	//1608
		else if(size==24)temp=asc2_2412[num][t];	//2412
		else return;								//ûеֿ
		for(t1=0;t1<8;t1++)
		{			    
			if(temp&0x80) LT738_DrawLine(x,y,x,y,Red);//LCD_Fast_DrawPoint(x,y,POINT_COLOR);
			else if(mode==0) LT738_DrawLine(x,y,x,y,White);//LCD_Fast_DrawPoint(x,y,BACK_COLOR);
			temp<<=1;
			y++;
			if(y>=LCD_YSIZE_TFT)return;		//
			if((y-y0)==size)
			{
				y=y0;
				x++;
				if(x>=LCD_XSIZE_TFT)return;	//
				break;
			}
		}  	 
	}  	    	   	 	  
}   
//m^n
//ֵ:m^nη.
u32 LCD_Pow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}			 
//ʾ,λΪ0,ʾ
//x,y :	 
//len :ֵλ
//size:С
//color:ɫ 
//num:ֵ(0~4294967295);	 
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size)
{         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/LCD_Pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,0); 
	}
} 







//////////////////////////////////////////////////////////////////////////////////		  
//ɨ
//tp:0,Ļ;1,(У׼ⳡ)
//ֵ:ǰ״̬.
//0,޴;1,д
u8 TP_Scan(u8 tp)
{			   
	if(PEN==0)//а
	{
		if(tp)TP_Read_XY2(&tp_dev.x[0],&tp_dev.y[0]);//ȡ
		else if(TP_Read_XY2(&tp_dev.x[0],&tp_dev.y[0]))//ȡĻ
		{
	 		tp_dev.x[0]=tp_dev.xfac*tp_dev.x[0]+tp_dev.xoff;//תΪĻ
			tp_dev.y[0]=tp_dev.yfac*tp_dev.y[0]+tp_dev.yoff;  
	 	} 
		if((tp_dev.sta&TP_PRES_DOWN)==0)//֮ǰûб
		{		 
			tp_dev.sta=TP_PRES_DOWN|TP_CATH_PRES;//  
			tp_dev.x[4]=tp_dev.x[0];//¼һΰʱ
			tp_dev.y[4]=tp_dev.y[0];  	   			 
		}			   
	}else
	{
		if(tp_dev.sta&TP_PRES_DOWN)//֮ǰǱµ
		{
			tp_dev.sta&=~(1<<7);//ǰɿ	
		}else//֮ǰûб
		{
			tp_dev.x[4]=0;
			tp_dev.y[4]=0;
			tp_dev.x[0]=0xffff;
			tp_dev.y[0]=0xffff;
		}	    
	}
	return tp_dev.sta&TP_PRES_DOWN;//صǰĴ״̬
}	  
//////////////////////////////////////////////////////////////////////////	 
//EEPROMĵַַ,ռ13ֽ(RANGE:SAVE_ADDR_BASE~SAVE_ADDR_BASE+12)
#define SAVE_ADDR_BASE 40
//У׼										    
void TP_Save_Adjdata(void)
{
	s32 temp;			 
	//У!		   							  
	temp=tp_dev.xfac*100000000;//xУ      
    AT24CXX_WriteLenByte(SAVE_ADDR_BASE,temp,4);   
	temp=tp_dev.yfac*100000000;//yУ    
    AT24CXX_WriteLenByte(SAVE_ADDR_BASE+4,temp,4);
	//xƫ
    AT24CXX_WriteLenByte(SAVE_ADDR_BASE+8,tp_dev.xoff,2);		    
	//yƫ
	AT24CXX_WriteLenByte(SAVE_ADDR_BASE+10,tp_dev.yoff,2);	
	//津
	AT24CXX_WriteOneByte(SAVE_ADDR_BASE+12,tp_dev.touchtype);	
	temp=0X0A;//У׼
	AT24CXX_WriteOneByte(SAVE_ADDR_BASE+13,temp); 
}
//õEEPROMУ׼ֵ
//ֵ1ɹȡ
//        0ȡʧܣҪУ׼
u8 TP_Get_Adjdata(void)
{					  
	s32 tempfac;
	tempfac=AT24CXX_ReadOneByte(SAVE_ADDR_BASE+13);//ȡ,ǷУ׼ 		 
	if(tempfac==0X0A)//ѾУ׼			   
	{    												 
		tempfac=AT24CXX_ReadLenByte(SAVE_ADDR_BASE,4);		   
		tp_dev.xfac=(float)tempfac/100000000;//õxУ׼
		tempfac=AT24CXX_ReadLenByte(SAVE_ADDR_BASE+4,4);			          
		tp_dev.yfac=(float)tempfac/100000000;//õyУ׼
	    //õxƫ
		tp_dev.xoff=AT24CXX_ReadLenByte(SAVE_ADDR_BASE+8,2);			   	  
 	    //õyƫ
		tp_dev.yoff=AT24CXX_ReadLenByte(SAVE_ADDR_BASE+10,2);				 	  
 		tp_dev.touchtype=AT24CXX_ReadOneByte(SAVE_ADDR_BASE+12);//ȡͱ
		if(tp_dev.touchtype)//X,YĻ෴
		{
			CMD_RDX=0X90;
			CMD_RDY=0XD0;	 
		}else				   //X,YĻͬ
		{
			CMD_RDX=0XD0;
			CMD_RDY=0X90;	 
		}		 
		return 1;	 
	}
	return 0;
}	 
//ʾַ
//u8* const TP_REMIND_MSG_TBL="Please use the stylus click the cross on the screen.The cross will always move until the screen adjustment is completed.";
 					  
//ʾУ׼()
void TP_Adj_Info_Show(u16 x0,u16 y0,u16 x1,u16 y1,u16 x2,u16 y2,u16 x3,u16 y3,u16 fac)
{	 

    //LT738_Print_Internal_Font_String(LCD_XSIZE_TFT-24,0,Red,White,"RST");	
	//POINT_COLOR=RED;
	LT738_Print_Internal_Font_String(40,100,Red,White,"x1:");
 	LT738_Print_Internal_Font_String(40+80,100,Red,White,"y1:");
	
 	LT738_Print_Internal_Font_String(40,120,Red,White,"x2:");
 	LT738_Print_Internal_Font_String(40+80,120,Red,White,"y2:");
	
	LT738_Print_Internal_Font_String(40,140,Red,White,"x3:");
 	LT738_Print_Internal_Font_String(40+80,140,Red,White,"y3:");
	
	LT738_Print_Internal_Font_String(40,160,Red,White,"x4:");
 	LT738_Print_Internal_Font_String(40+80,160,Red,White,"y4:");
	
 	LT738_Print_Internal_Font_String(40,180,Red,White,"fac is:"); 
     
	
	LCD_ShowNum(40+24,100,x0,4,16);		//ʾֵ
	LCD_ShowNum(40+24+80,100,y0,4,16);	//ʾֵ
	
	LCD_ShowNum(40+24,120,x1,4,16);		//ʾֵ
	LCD_ShowNum(40+24+80,120,y1,4,16);	//ʾֵ
	
	LCD_ShowNum(40+24,140,x2,4,16);		//ʾֵ
	LCD_ShowNum(40+24+80,140,y2,4,16);	//ʾֵ
	
	LCD_ShowNum(40+24,160,x3,4,16);		//ʾֵ
	LCD_ShowNum(40+24+80,160,y3,4,16);	//ʾֵ
	
 	LCD_ShowNum(40+56,180,fac,3,16); 	//ʾֵ,ֵ95~105Χ֮.

	
	
	
	
	
}
		 
//У׼
//õĸУ׼
void TP_Adjust(void)
{								 
	u16 pos_temp[4][2];//껺ֵ
	u8  cnt=0;	
	u16 d1,d2;
	u32 tem1,tem2;
	double fac; 	
	u16 outtime=0;
 	cnt=0;		
	LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
	LT738_Print_Internal_Font_String(0,40,Red,White,"Please use the stylus click the cross on the screen.The cross will always move until the screen adjustment is completed.");
	TP_Drow_Touch_Point(20,20,Red);//1
	tp_dev.sta=0;//ź 
	tp_dev.xfac=0;//xfacǷУ׼,У׼֮ǰ!	 
	while(1)//10ûа,Զ˳
	{
		tp_dev.scan(1);//ɨ
		if((tp_dev.sta&0xc0)==TP_CATH_PRES)//һ(ʱɿ.)
		{	
			outtime=0;		
			tp_dev.sta&=~(1<<6);//ǰѾ.
						   			   
			pos_temp[cnt][0]=tp_dev.x[0];
			pos_temp[cnt][1]=tp_dev.y[0];
			cnt++;	  
			switch(cnt)
			{			   
				case 1:						 
					TP_Drow_Touch_Point(20,20,White);				//1 
					TP_Drow_Touch_Point(LCD_XSIZE_TFT-20,20,Red);	//2
					break;
				case 2:
 					TP_Drow_Touch_Point(LCD_XSIZE_TFT-20,20,White);	//2
					TP_Drow_Touch_Point(20,LCD_YSIZE_TFT-20,Red);	//3
					break;
				case 3:
 					TP_Drow_Touch_Point(20,LCD_YSIZE_TFT-20,White);			//3
 					TP_Drow_Touch_Point(LCD_XSIZE_TFT-20,LCD_YSIZE_TFT-20,Red);	//4
					break;
				case 4:	 //ȫĸѾõ
	    		    //Ա
					tem1=abs(pos_temp[0][0]-pos_temp[1][0]);//x1-x2
					tem2=abs(pos_temp[0][1]-pos_temp[1][1]);//y1-y2
					tem1*=tem1;
					tem2*=tem2;
					d1=sqrt(tem1+tem2);//õ1,2ľ
					
					tem1=abs(pos_temp[2][0]-pos_temp[3][0]);//x3-x4
					tem2=abs(pos_temp[2][1]-pos_temp[3][1]);//y3-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=sqrt(tem1+tem2);//õ3,4ľ
					fac=(float)d1/d2;
					if(fac<0.95||fac>1.05||d1==0||d2==0)//ϸ
					{
						cnt=0;
 				    	TP_Drow_Touch_Point(LCD_XSIZE_TFT-20,LCD_YSIZE_TFT-20,White);	//4
   	 					TP_Drow_Touch_Point(20,20,Red);								//1
 						TP_Adj_Info_Show(pos_temp[0][0],pos_temp[0][1],pos_temp[1][0],pos_temp[1][1],pos_temp[2][0],pos_temp[2][1],pos_temp[3][0],pos_temp[3][1],fac*100);//ʾ   
 						continue;
					}
					tem1=abs(pos_temp[0][0]-pos_temp[2][0]);//x1-x3
					tem2=abs(pos_temp[0][1]-pos_temp[2][1]);//y1-y3
					tem1*=tem1;
					tem2*=tem2;
					d1=sqrt(tem1+tem2);//õ1,3ľ
					
					tem1=abs(pos_temp[1][0]-pos_temp[3][0]);//x2-x4
					tem2=abs(pos_temp[1][1]-pos_temp[3][1]);//y2-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=sqrt(tem1+tem2);//õ2,4ľ
					fac=(float)d1/d2;
					if(fac<0.95||fac>1.05)//ϸ
					{
						cnt=0;
 				    	TP_Drow_Touch_Point(LCD_XSIZE_TFT-20,LCD_YSIZE_TFT-20,White);	//4
   	 					TP_Drow_Touch_Point(20,20,Red);								//1
 						TP_Adj_Info_Show(pos_temp[0][0],pos_temp[0][1],pos_temp[1][0],pos_temp[1][1],pos_temp[2][0],pos_temp[2][1],pos_temp[3][0],pos_temp[3][1],fac*100);//ʾ   
						continue;
					}//ȷ
								   
					//Խ
					tem1=abs(pos_temp[1][0]-pos_temp[2][0]);//x1-x3
					tem2=abs(pos_temp[1][1]-pos_temp[2][1]);//y1-y3
					tem1*=tem1;
					tem2*=tem2;
					d1=sqrt(tem1+tem2);//õ1,4ľ
	
					tem1=abs(pos_temp[0][0]-pos_temp[3][0]);//x2-x4
					tem2=abs(pos_temp[0][1]-pos_temp[3][1]);//y2-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=sqrt(tem1+tem2);//õ2,3ľ
					fac=(float)d1/d2;
					if(fac<0.95||fac>1.05)//ϸ
					{
						cnt=0;
 				    	TP_Drow_Touch_Point(LCD_XSIZE_TFT-20,LCD_YSIZE_TFT-20,White);	//4
   	 					TP_Drow_Touch_Point(20,20,Red);								//1
 						TP_Adj_Info_Show(pos_temp[0][0],pos_temp[0][1],pos_temp[1][0],pos_temp[1][1],pos_temp[2][0],pos_temp[2][1],pos_temp[3][0],pos_temp[3][1],fac*100);//ʾ   
						continue;
					}//ȷ
					//
					tp_dev.xfac=(float)(LCD_XSIZE_TFT-40)/(pos_temp[1][0]-pos_temp[0][0]);//õxfac		 
					tp_dev.xoff=(LCD_XSIZE_TFT-tp_dev.xfac*(pos_temp[1][0]+pos_temp[0][0]))/2;//õxoff
						  
					tp_dev.yfac=(float)(LCD_YSIZE_TFT-40)/(pos_temp[2][1]-pos_temp[0][1]);//õyfac
					tp_dev.yoff=(LCD_YSIZE_TFT-tp_dev.yfac*(pos_temp[2][1]+pos_temp[0][1]))/2;//õyoff  
					if(abs(tp_dev.xfac)>2||abs(tp_dev.yfac)>2)//Ԥ෴.
					{
						cnt=0;
 				    	TP_Drow_Touch_Point(LCD_XSIZE_TFT-20,LCD_YSIZE_TFT-20,White);	//4
   	 					TP_Drow_Touch_Point(20,20,Red);								//1
						//LCD_ShowString(40,26,lcddev.width,lcddev.height,16,"TP Need readjust!");
						LT738_Print_Internal_Font_String(40,26,Red,White,"TP Need readjust!");
						tp_dev.touchtype=!tp_dev.touchtype;//޸Ĵ.
						if(tp_dev.touchtype)//X,YĻ෴
						{
							CMD_RDX=0X90;
							CMD_RDY=0XD0;	 
						}else				   //X,YĻͬ
						{
							CMD_RDX=0XD0;
							CMD_RDY=0X90;	 
						}			    
						continue;
					}		
					//POINT_COLOR=BLUE;
					//LCD_Clear(WHITE);//
					LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
					//LCD_ShowString(35,110,lcddev.width,lcddev.height,16,"Touch Screen Adjust OK!");//У
					LT738_Print_Internal_Font_String(35,110,Red,White,"Touch Screen Adjust OK!");
					delay_ms(1000);
					TP_Save_Adjdata();  
					LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
 					//LCD_Clear(WHITE);//   
					return;//У				 
			}
		}
		delay_ms(10);
		outtime++;
		if(outtime>1000)
		{
			TP_Get_Adjdata();
			break;
	 	} 
 	}
}	

#endif



//ʼ  		    
//ֵ:0,ûнУ׼
//       1,йУ׼
u8 TP_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;	
	  
	  if(GT1151==1)
	  {
			GT1151_Init();
	  tp_dev.scan=GT1151_Scan;	//ɨ躯ָGT1151ɨ
	    return 0;
  	}
	  if(GT911==1)
	 { 
		   GT911_Init();
	     tp_dev.scan=GT911_Scan;	//ɨ躯ָGT911ɨ
	   return 0;
  	}
	 if(GT9271==1)
	 { 
		   GT9271_Init();
	     tp_dev.scan=GT9271_Scan;	//ɨ躯ָGT911ɨ
	   return 0;
  	}
	  if(FT5426==1)
	  	{
				FT5206_Init();
	      tp_dev.scan=FT5206_Scan;	//ɨ躯ָFT5426ɨ
	    return 0;
  	 }
	  else 
	  {	
	  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB|RCC_AHB1Periph_GPIOC|RCC_AHB1Periph_GPIOF, ENABLE);//ʹGPIOB,C,Fʱ

    //GPIOB1,2ʼ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1 | GPIO_Pin_2;//PB1/PB2 Ϊ
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;//ģʽ
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;//
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;//100MHz
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//
    GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ
		
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;//PB0Ϊ
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
	  GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ
		
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;//PC13Ϊ
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
	  GPIO_Init(GPIOC, &GPIO_InitStructure);//ʼ	
		
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;//PF11
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
	  GPIO_Init(GPIOF, &GPIO_InitStructure);//ʼ			
		
   
		TP_Read_XY(&tp_dev.x[0],&tp_dev.y[0]);//һζȡʼ	 
		AT24CXX_Init();		//ʼ24CXX
		if(TP_Get_Adjdata())return 0;//ѾУ׼
		else			   //δУ׼?
		{ 										    
			//LCD_Clear(WHITE);//
			LT738_DrawSquare_Fill(0,0,LCD_XSIZE_TFT,LCD_YSIZE_TFT,White);
			TP_Adjust();  	//ĻУ׼ 
			TP_Save_Adjdata();	 
		}			
		TP_Get_Adjdata();	
	}
	return 1; 					 
}
